#!/usr/bin/perl
# Created:20040506
# By Jeff Connelly

# Given the weight of a collection of US coins in grams,
# determine its value in dollars

$weight = $ARGV[0];
if (!$weight) {
    print "usage: $0 <weight>\n";
    print "will count nickels, dimes, quarters, and halfs\n";
    exit -1;
}

# Weight is now in 10-thousandths of a gram, integer
$weight *= 1000;
$weight = int($weight);
#print "$weight\n";

# objective: solve W=5000*N + 2268*D, given W, such that N and D are integers

# W=5000N + 2268D
# (W-2268D)/5000

# THIS DOESN'T WORK
# see weight-multiples.txt for information
#$nickels = int($weight / 5);
#$dimes = int(($weight - 5 * $nickels) / 2.268);  # really dimes quarters + halfs
#$rest = $weight - 5 * $nickels - 2.268 * $dimes;
#$amt = 0.05 * $nickels + 0.10 * $dimes;

# Iterative approach (20040605) - this works
# N = (W - 2268*D) / 5000
$max = 20;
$dimes1 = -1;
while ($dimes1++) {
    $dimes = $dimes1;
    $nickels = ($weight - 2268 * $dimes) / 5000;
    #print "$dimes\t$nickels\n";
    if ($nickels == int($nickels)) {
        last;
    }
}

# The easy part
$amt = $dimes * 0.10 + $nickels * 0.05;
print "N=$nickels\n";
print "D=$dimes\n\n";
printf '$%.2f%s', $amt, "\n";
print "(remainder=$rest)\n" if $rest;

